#!/usr/bin/env python3.7
# -*- coding: utf-8 -*-
"""
  Lanceur-IP.py		02 Décembre 2018	Mars 2019
  					Version 104	Juin 2021
					Version 105	Juillet 2021
					Version 107, Aout 2021	Refonte du TRANSFERT en fenetre TopLevel
											Ajout Copie Ecran en fenetre Toplevel

"""  

#import os,sys
import shutil
from tkinter import *
#import tkinter.tix as tix
import subprocess
from subprocess import call
import pickle
from time import sleep
from functools import partial
from tkinter.scrolledtext import *
from tkinter import messagebox
from tkinter.filedialog import askdirectory
from tkinter.filedialog import askopenfilename
from datetime import datetime


#Librairie générale
sys.path.append ("./Lib")
import clsCDBI
lib1=clsCDBI.CDBI1()
import clsSSH
SSH=clsSSH.SSH()
import clsToolTip
Tip=clsToolTip.ToolTip

def curseur_main(e):
	fen1.configure(cursor='hand2')

def curseur_fleche(e):
	fen1.configure(cursor='arrow')

def ENR_Config(f):
	try:
		with open(f,'w') as nf:
			nf.write(str(VarNbIP.get()) + "|" + str(userN.get()) + "|" + str(userP.get()) + "|"+ str(VarTEST.get()) + '\n')
			nf.close()
		with open(f,'a') as nf:
			for i in range(0,VarNbIP.get()):
				if VarIP[i].get() == "":
					d="|0||-"
				else:
					d = VarNOM[i].get() + '|' + str(VarBrowser[i].get()) + '|' + VarIP[i].get() + '|' + MAJdate[i]
				nf.write(str(d) + '\n')
			nf.close()
		#Copie de sauvegarde .bak
		f2=sys.path[0] + "/Lanceur-IP-107.bak"
		shutil.copy2(f,f2)
		return True
	except:
		return False
		
def LIRE_Config(f):
	global VarNOM,VarBrowser,VarIP,MAJdate,userN,userP
	if lib1.Existe(f):
		try:
			with open(f,'r') as nF:
				i=0
				for line in nF:
					#première ligne pour Config générale
					if i == 0:
						l=line.split("|")
						VarNbIP.set(int(l[0]))
						userN.set(l[1])
						userP.set(l[2])
						VarTEST.set(l[3][:-1])
						VarNOM=[]
						VarIP=[]
						MAJdate=[]
						VarBrowser=[]
						for j in range(0,VarNbIP.get()):
							VarNOM.append(StringVar())
							VarIP.append(StringVar())
							VarBrowser.append(IntVar())
							MAJdate.append("")
					else:
						t=[]
						t=tuple(map(str,line.split('|')))
						VarNOM[i-1].set(t[0])
						VarBrowser[i-1].set(int(t[1]))
						r=t[2]
						VarIP[i-1].set(r)
						r=t[3][:-1]
						if r == "":r="???"
						MAJdate[i-1]=r
					i+=1
				nF.close()
			return True
		except:
			nF.close
			return False
	else:
		VarNbIP.set(5)
		VarNOM=[]
		VarIP=[]
		VarBrowser=[]
		MAJdate=[]
		for j in range(0,VarNbIP.get()):
			VarNOM.append(StringVar())
			VarIP.append(StringVar())
			VarBrowser.append(IntVar())
			MAJdate.append("")
			
		return False

def ValidPASS(e):
	ENR_Config(FichierConf)
	AFFI_CAN1(False)

def REFRESH(lance):
	global NouvNbIP,VarNbIP
	""" si lance appel au Lancement du programme
		si non appel par le bouton RAFFRAICHIR
	"""
	if  not lance:
		VarNbIP=NouvNbIP
		ENR_Config(FichierConf)
		can0.destroy()
		can1.destroy()

	if LIRE_Config(FichierConf):
		NouvNbIP=VarNbIP
		FenDIM()
		AFFI_CAN0()
		AFFI_CAN1(False)
		fen1.update()
		if VarTEST.get():TESTIP()
	else:
		#ERREUR ou pas de Config
		VarNbIP.set(5)
		NouvNbIP=VarNbIP
		FenDIM()
		AFFI_CAN0()
		AFFI_CAN1(True)
	if userN.get() == "":
		messagebox.showwarning("ATTENTION","Rentrez User SSH\net Enter")
	if userP.get() == "":
		EntreeP.configure(bg='pink')
		messagebox.showwarning("ATTENTION","Rentrez Mot de Passe SSH\net Enter")

def PointBout(b,ok):
	coulbg='lightgreen' if ok else 'pink'
	for c in can0.winfo_children():
		if isinstance(c,Button):
			if c.tag == b:
				c.configure(bg=coulbg)
				break

def PRESENT(n):
	#Sauf si un lancement Browser
	#Sauf si Passe est vide
	if VarBrowser[n].get() == 1:
		return True
	elif userN.get() == "" or userP.get() == "":
		return False
	else:
		#Rempli la ligne de commande
		global cmd
		cmd=[]
		cmd.append (VarIP[n].get())
		cmd.append (userN.get())
		cmd.append (userP.get())
		cmd.append ("")
		t=SSH.Nom_Raspi(cmd)
		return False if t == "" else t

def TESTIP():
	if userP.get() == "":
		EntreeP.configure(bg='pink')
		messagebox.showwarning("ATTENTION","Rentrez Mot de Passe SSH\net Enter")
		return

	AFFI_CAN0()
	for i in range (0,VarNbIP.get()):
		if not VarBrowser[i].get():
			affiT.delete('0.0',END)
			affiT.insert(END,"ANALYSE DES IP PRESENTS ..." + str(i))
			affiT.update()
			r=PRESENT(i)
			if r == False:
				if VarNOM[i].get() != "":EntreeNOM[i].configure(bg='pink')
				checkBW[i].configure(state=DISABLED)
				bouL[i].configure(state=DISABLED)
				bouMAJ[i].configure(state=DISABLED)
				bouT[i].configure(state=DISABLED)
				bouRB[i].configure(state=DISABLED)
				bouSD[i].configure(state=DISABLED)
			else:
				VarNOM[i].set(str(r))
	ENR_Config(FichierConf)
	affiT.insert(END,' >> TEST-IP TERMINE\n')
	affiT.update()

def Lancer(n):
	p=PRESENT(n)
	if not p:
		affiT.insert(END,str(VarNOM[n].get()) + " >> Non Disponible\n")
		affiT.update()
		PointBout(n,False)
	else:
		PointBout(n,True)

		if VarBrowser[n].get() == 1 and VarIP[n].get() != "":
			cmd="chromium-browser " + VarIP[n].get() + " &"
			call(cmd,shell=True)
			fen1.iconify()
		elif VarIP[n].get() != "":
			#Si pas IP local
			if not str(VarIP[n].get()) in str(localIP):
				cmd="vncviewer -username pi -passwd cdbi " + VarIP[n].get()
				call(cmd,shell=True)
				fen1.iconify()
			else:
				affiT.delete('0.0',END)
				t="PAS DE VNC SUR IP LOCAL\n"
				affiT.insert(END,t)
				affiT.update()
				PointBout(n,False)
		lib1.Effa_Termi()

def MAJ(n):
	global MAJdate
	p=PRESENT(n)
	if not p:
		affiT.insert(END,str(VarNOM[n].get()) + " >> Non Disponible\n")
		affiT.update()
		PointBout(n+100,False)
		return False
	else:
		affiT.delete('0.0',END)
		affiT.insert(END,"MISE A JOUR EN COURS >> " + str(VarNOM[n].get()) + "\n")
		pt2= "1.85"
		pt1= "1.0"
		affiT.tag_add('pointage',pt1,pt2)
		affiT.update()
		t=SSH.MAJ(cmd)
		affiT.insert(END,t + "\n")
		affiT.update()
		MAJdate[n]=datetime.now().strftime('%d/%m/%Y')
		bouMAJ[n].configure(text="MAJ > " + MAJdate[n])
		ENR_Config(FichierConf)
		PointBout(n+100,True)

def TEMPCPU(n):
	p=PRESENT(n)
	if not p:
		affiT.insert(END,str(VarNOM[n].get()) + " >> Non Disponible\n")
		affiT.update()
		return False
	else:
		t=SSH.CPUtemp(cmd)
		if t !="":
			t="TEMPERATURE >> " + p + " >> " + t +"\n"
			affiT.insert(END,t)
			affiT.update()

def CpuInfos(n,e):
	affiT.delete('0.0',END)
	affiT.update()
	if not VarBrowser[n].get():
		p=PRESENT(n)
		if not p:
			affiT.insert(END,str(VarNOM[n].get()) + " >> Non Disponible\n")
			affiT.update()
		else:
			t=SSH.CPU_INFO(cmd)
			if t !="":
				t="INFOS >> " + p + "\n " + t +"\n"
				affiT.insert(END,t)
				pt2= "1.85"
				pt1= "1.0"
				affiT.tag_add('pointage',pt1,pt2)
				affiT.update()
	else:
		affiT.insert(END,"Pas d'INFOS sur BROWSER")
	affiT.update()

def ReBoot(n):
	p=PRESENT(n)
	affiT.delete("0.0",END)
	if not p:
		affiT.insert(END,str(VarNOM[n].get()) + " >> Non Disponible\n")
		affiT.update()
		PointBout(n+300,False)
		return False
	else:
		t="Voulez-vous Relancer " + VarNOM[n].get() + " ?"
		if messagebox.askyesno("RE-BOOT",t ) == True:
			t="REBOOT  >>> " + p + " ....PATIENCE...Attendre la Confirmation\n"
			affiT.insert(END,t)
			affiT.update()
			t=SSH.REBOOT(cmd)
			sleep(10)
			#Attend le ReBoot 10 fois
			cpt=0
			while not PRESENT(n) or cpt < 10:
				sleep(1)
				cpt +=1
			t= "REBOOT  >>> " + p + "  OK\n"
			affiT.insert(END,t)
			affiT.update()
			PointBout(n+300,True)

def ShutD(n):
	p=PRESENT(n)
	if not p:
		affiT.insert(END,str(VarNOM[n].get()) + " >> Non Disponible\n")
		affiT.update()
		PointBout(n+400,False)
		return False
	else:
		t="Voulez-vous arreter " + VarNOM[n].get() + " ?"
		if messagebox.askyesno("ARRET",t ) == True:
			SSH.SHUTD(cmd)
			t="ARRET  >>> " + p + "\n"
			affiT.insert(END,t)
			affiT.update()
			PointBout(n+400,True)
			TESTIP()

def ScanIP(ad):
	affiT.delete('0.0',END)
	if ad == 1:
		ad1=2
		ad2=100
		t="SCAN IP EN COURS (2/100): "
	elif ad == 2:
		ad1=100
		ad2=200
		t="SCAN IP EN COURS (100/200): "
	rr=""
	for k in range (ad1,ad2):
		affiT.delete('0.0',END)
		affiT.insert(END,t + str(k))
		pt2= "1.85"
		pt1= "1.0"
		affiT.tag_add('pointage',pt1,pt2)
		affiT.update()
		cmd=[]
		IP="192.168.1." + str(k)
		cmd.append (IP)
		cmd.append (userN.get())
		cmd.append (userP.get())
		cmd.append ("")
		r=SSH.Nom_Raspi(cmd)
		if r != "":
			rr += r + " >>> " + str(k) + "\n"
	affiT.delete('0.0',END)
	affiT.insert(END,t + "  TERMINE\n")
	pt2= "1.85"
	pt1= "1.0"
	affiT.tag_add('pointage',pt1,pt2)
	affiT.insert(END,rr)
	affiT.update

def ToutTEMP():
	affiT.delete('0.0',END)
	for i in range (0,VarNbIP.get()):
		if not VarBrowser[i].get() and VarNOM[i].get() != "":
			TEMPCPU(i)
	affiT.insert(END,"TERMINE\n")

def ChoixORID():
	#Dossier   Efface CopieTAB[]
	global typeREP,CopieTAB
	affiT.delete('0.0',END)
	CopieTAB=[]
	listF.delete(0,END)
	rep=askdirectory(initialdir="/home/pi",title='Dossier Origine')
	if len(rep) > 0:
		VarORI.set(rep)
		typeREP=True
		fen2.destroy()
		AFFI_FEN2()
	else:
		VarORI.set("")

def ChoixORIF(e):
	global typeREP,CopieTAB
	initD=lib1.Extract_Chemin(VarORI.get(),True)
	if initD == "":initD="/home/pi"
	#Met Fichiers dans CopieTAB[]
	fi=askopenfilename(initialdir=initD,title='Fichiers Origines')
	if len(fi) > 0:
		VarORI.set(fi)
		typeREP=False
		CopieTAB.append(fi)
		fen2.destroy()
		AFFI_FEN2()
	else:
		ChoixORID()

def RazCOPI():
	global CopieTAB,typeREP
	CopieTAB=[]
	listF.delete(0,END)
	typeREP=False
	affiT.delete("0.0",END)
	VarORI.set("")
	VarDESTI.set("/home/pi/")
	bouCOPIE.configure(state=DISABLED)

def ChoixIP(n,e):
	#met IP destination pour les copies si pas local ou Browser
	affiT.delete("0.0",END)
	affiT.update()
	if fen2 != None:fen2.destroy()
	if VarIP[n].get() != localIP and not VarBrowser[n].get():
		VarDESTIIP.set(VarIP[n].get())
		VarDESTI.set("/home/pi/")
		AFFI_FEN2()
	else:
		VarDESTIIP.set("")
		affiT.insert(END,"Pas de TRANSFERT\n en LOCAL ou Browser\n")
		affiT.update()

def VoirDESTI(e):
	#Lit le Dossier Destination
	affiT.delete("0.0",END)
	affiT.insert(END,str(VarDESTIIP.get()) + " : " + str(VarDESTI.get()) + "\n")
	pt2= "1.85"
	pt1= "1.0"
	affiT.tag_add('pointage',pt1,pt2)
	cmd=[]
	cmd.append (str(VarDESTIIP.get()))		#IP destination
	cmd.append (userN.get())				#Utilisateur
	cmd.append (userP.get())				#Passe
	cmd.append ("")							#
	cmd.append ("")							#
	cmd.append (str(VarDESTI.get()))		#Chemin Destination
	r=SSH.LireDossier(cmd)
	affiT.insert(END,r)

def VoirDESTI_LOCAL_CE(e):
	#Lit le Dossier Destination local Copie Ecran
	fen1.deiconify()
	affiT.delete("0.0",END)
	affiT.insert(END,str(VarDESTICE.get()) + "\n")
	pt2= "1.85"
	pt1= "1.0"
	affiT.tag_add('pointage',pt1,pt2)
	cmd="ls " + str(VarDESTICE.get())
	r=lib1.run_cmd(cmd)
	affiT.insert(END,r)

def TRANSFERT():
	affiT.delete("0.0",END)
	if fen2 != None:
		VarDESTIIP.set("")
		fen2.destroy()
	AFFI_FEN2()

def COPIFICH():
	#Rempli la ligne de commande
	global CopieTAB
	affiT.delete("0.0",END)
	if typeREP:
		#Copier 1 Dossier
		cmd=[]
		cmd.append (str(VarDESTIIP.get()))		#IP destination
		cmd.append (userN.get())				#Utilisateur
		cmd.append (userP.get())				#Passe
		cmd.append (typeREP)					#True si Dossier
		cmd.append (str(VarORI.get()))			#Chemin Origine du Dossier
		cmd.append (str(VarDESTI.get()))		#Chemin Destination
		r=SSH.TRANSFERT(cmd)
		affiT.insert(END,r)
		affiT.update()
	else:
		#Copier les Fichiers de CopieTAB[]
		for i in range(0,len(CopieTAB)):
			cmd=[]
			cmd.append (str(VarDESTIIP.get()))		#IP destination
			cmd.append (userN.get())				#Utilisateur
			cmd.append (userP.get())				#Passe
			cmd.append (typeREP)					#False si Fichiers
			cmd.append (str(CopieTAB[i]))			#Chemin Origine
			cmd.append (str(VarDESTI.get()))		#Chemin Destination
			r=SSH.TRANSFERT(cmd)
			affiT.insert(END,r)
			affiT.update()
	CopieTAB=[]
	VarORI.set("")
	fen2.destroy()

def SendCMD(n):
	affiT.delete('0.0',END)
	cmd=[]
	cmd.append (str(VarIP[n].get()))		#IP destination
	cmd.append (userN.get())				#Utilisateur
	cmd.append (userP.get())				#Passe
	cmd.append (str(VarCMD.get()))			#Commande
	cmd.append ("")							#
	cmd.append ("")							#
	r=SSH.COMMAND(cmd)
	if r == False:
		affiT.insert(END,"ERREUR")
	else:
		affiT.insert(END,r)
	affiT.update()

def CAPTURE():
	fen1.iconify()
	if fen3 != None:fen3.destroy()
	affiT.delete('0.0',END)
	AFFI_FEN3()

def CAPT_ECRAN():
	cmd=""
	f=str(VarDESTICE.get()) + "CAPTE_" + datetime.now().strftime('%d-%m-%Y-%H:%M:%S') + ".jpg"
	if VarCAPT.get() == 0:
		cmd="scrot -cd10 " + f
	elif VarCAPT.get() == 1:
		cmd="scrot -cd10 -ub " + f
	elif VarCAPT.get() == 2:
		cmd="scrot -cd10 -s " + f
	if cmd != "":
		#fen3.iconify()
		try:
			lib1.run_cmd(cmd)
			affiT.insert(END,"CAPTURE TERMINEE")
		except:
			affiT.insert(END,"ERREUR CAPTURE")
			#fen3.deconify()

def AFFI_CAN0():
	global can0,infoIP,affiT,EntreeNOM,can0H
	global checkBW,bouL,bouMAJ,bouT,bouRB,bouSD
	W,H,X,Y=lib1.FenetreDIM(fen1)	#Dimensions de la Fenetre Principale
	can0H=VarNbIP.get()*25+20		#Selon le nombre de Lignes
	can0 = Canvas(fen1,highlightbackground='blue',highlightcolor='blue',highlightthickness=2,bg='lightyellow',width=W-15,height=can0H)
	can0.place(x=5,y=5)
	can0.pack_propagate(True)
	EntreeNOM=[]
	tipNOM=[]
	EntreeIP=[]
	tipIP=[]
	checkBW=[]
	bouL=[]
	bouMAJ=[]
	bouT=[]
	bouRB=[]
	bouSD=[]

	for i in range (0,VarNbIP.get()):
		coulbg=coulBG1 if i%2 else coulBG2

		EntreeNOM.append(Entry(can0,textvariable=VarNOM[i],font=("Arial",10),width=16,bg=coulbg,fg=coulFG1,relief='flat'))
		EntreeNOM[i].place(x=5,y=5+25*i)
		EntreeNOM[i].bind("<Double-Button-1>",partial(CpuInfos,i))
		
		EntreeIP.append(Entry(can0,textvariable=VarIP[i],font=("Arial",10),width=20,bg=coulbg,fg=coulFG1,relief='flat'))
		EntreeIP[i].place(x=125,y=5+25*i)
		EntreeIP[i].bind("<Double-Button-1>",partial(ChoixIP,i))
		#EntreeIP[i].bind("<Return>",partial(TESTIP,False))		#Fonctionne pas ??
		
		checkBW.append(Checkbutton(can0,text="Browser",variable=VarBrowser[i],bg=coulbg,fg=coulFG1))
		checkBW[i].place(x=275,y=6+25*i)
		checkBW[i].bind("<Enter>",curseur_main)
		checkBW[i].bind("<Leave>",curseur_fleche)
		if VarBrowser[i].get():
			EntreeNOM[i].configure(fg=coulFG2)
		else:
			tipNOM.append(Tip(EntreeNOM[i],"Double-Click pour Infos " + str(VarNOM[i].get())))
			tipIP.append(Tip(EntreeIP[i],"Double-Click pour TRANSFERT vers " + str(VarNOM[i].get())))
		
		bouL.append(Button(can0,text='Voir',command=partial(Lancer,i),bg=coulbg,fg=coulFG1))
		bouL[i].place(x=365,y=6+25*i,width=55,height=20)
		bouL[i].tag=i
		bouL[i].bind("<Enter>",curseur_main)
		bouL[i].bind("<Leave>",curseur_fleche)
		
		bouMAJ.append(Button(can0,text="MAJ > "+MAJdate[i],command=partial(MAJ,i),bg=coulbg,fg=coulFG1))
		bouMAJ[i].place(x=430,y=6+25*i,width=150,height=20)
		bouMAJ[i].tag=i+100
		bouMAJ[i].bind("<Enter>",curseur_main)
		bouMAJ[i].bind("<Leave>",curseur_fleche)

		bouT.append(Button(can0,text='CMD',command=partial(SendCMD,i),bg=coulbg,fg=coulFG1))
		bouT[i].place(x=590,y=6+25*i,width=55,height=20)
		bouT[i].tag=i+200
		bouT[i].bind("<Enter>",curseur_main)
		bouT[i].bind("<Leave>",curseur_fleche)
		
		bouRB.append(Button(can0,text='ReBoot',command=partial(ReBoot,i),bg=coulbg,fg=coulFG1))
		bouRB[i].place(x=650,y=6+25*i,width=55,height=20)
		bouRB[i].tag=i+300
		bouRB[i].bind("<Enter>",curseur_main)
		bouRB[i].bind("<Leave>",curseur_fleche)
		
		bouSD.append(Button(can0,text='Arret',command=partial(ShutD,i),bg=coulbg,fg=coulFG1))
		bouSD[i].place(x=710,y=6+25*i,width=55,height=20)
		bouSD[i].tag=i+400
		bouSD[i].bind("<Enter>",curseur_main)
		bouSD[i].bind("<Leave>",curseur_fleche)

	affiT=ScrolledText(can0,bg='lightyellow',width=85,height=int((VarNbIP.get()-1)*1.5),border=1,font=("Arial",10),fg=coulFG1,relief='solid')
	affiT.configure(wrap=WORD,autoseparators=True)
	affiT.place(x=780,y=10)
	affiT.tag_configure('pointage',font='Arial 10 bold')
	affiT.tag_configure('normal',font='Arial 10')

	fen1.update()

	#Position de la dernière ligne
	y=bouSD[VarNbIP.get()-1].winfo_y() + 5
	x=bouSD[VarNbIP.get()-1].winfo_x() + 70
	EntreeCMD=Entry(can0,textvariable=VarCMD,font=("Arial",12),width=63,bg='white',fg=coulFG1,relief='solid',bd=1)
	EntreeCMD.place(x=x,y=y)
	tipCMD=Tip(EntreeCMD,"Ligne de Commande pour les Boutons CMD")

	for i in range (0,VarNbIP.get()):
		if VarBrowser[i].get() or VarNOM[i].get() == "":
			bouMAJ[i].configure(state= DISABLED)
			bouT[i].configure(state= DISABLED)
			bouRB[i].configure(state= DISABLED)
			bouSD[i].configure(state= DISABLED)
		if VarNOM[i].get() == "" or VarIP[i].get() == "":
			checkBW[i].configure(state=DISABLED)
			bouL[i].configure(state= DISABLED)
	fen1.update()

def AFFI_CAN1(err):
	global can1,EntreeP,bouSCAN1,bouSCAN2,infoIP
	#Dimensions de la Fenetre Principale
	W,H,X,Y=lib1.FenetreDIM(fen1)
	can1 = Canvas(fen1,highlightbackground='blue',highlightcolor='grey',highlightthickness=2,bg='lightgrey',width=W-15,height=60)
	can1.place(x=5,y=can0H+15)
	can1.pack_propagate(True)
	
	infoIP=Label(can1,text="Local IP: " + localIP,font=("Arial",12,'bold'),bg="lightgrey",fg='green')
	infoIP.place(x=10,y=5)

	E=str(scrW) + "x" + str(scrH)
	if err:
		infoERR=Label(can1,text="ERREUR CONFIG  " + E,font=("Arial",10),bg="lightgrey",fg='red')
	else:
		infoERR=Label(can1,text="CONFIG OK  " + E,font=("Arial",10),bg="lightgrey",fg=coulFG1)
	infoERR.place(x=15,y=30)

	infoNBL=Label(can1,text="Nb Lignes",font=("Arial",10),bg="lightgrey",fg=coulFG1)
	infoNBL.place(x=210,y=3)
	EntreeNB=Spinbox(can1,from_=5,to=30,textvariable=NouvNbIP,font=("Arial",14),width=3,bg="lightyellow",fg='black')
	EntreeNB.place(x=210,y=23)
	tipNB=Tip(EntreeNB,"Attention:\nEfface les non visibles")

	infoSSH=Label(can1,text="User et Passe SSH",font=("Arial",10),bg="lightgrey",fg=coulFG1)
	infoSSH.place(x=280,y=3)
	EntreeN=(Entry(can1,textvariable=userN,font=("Arial",14),width=5,bg='lightyellow',fg='black',relief='solid',bd=1))
	EntreeN.place(x=280,y=23)
	tipN=Tip(EntreeN,"Utilisateur\npi par défaut")
	EntreeN.bind("<Return>",ValidPASS)
	EntreeN.bind("<KP_Enter>",ValidPASS)
	EntreeP=(Entry(can1,textvariable=userP,font=("Arial",14),width=10,bg='lightyellow',fg='black',relief='solid',bd=1))
	EntreeP.place(x=340,y=23)
	tipP=Tip(EntreeP,"Tous les PI\n doivent avoir le meme Passe")
	EntreeP.bind("<Return>",ValidPASS)
	EntreeP.bind("<KP_Enter>",ValidPASS)

	bouV= Button(can1,text="ENR/RAFRAICHIR",command=partial(REFRESH,False),bg='lightgrey',fg=coulFG1)
	bouV.place(x=455,y=15,width=145,height=30)
	tipV=Tip(bouV,"Sauve la Config\nEt Raffraichi")

	bouTEMP= Button(can1,text="TEMPERATURES",command=ToutTEMP,bg='lightgrey',fg=coulFG1)
	bouTEMP.place(x=610,y=15,width=120,height=30)
	tipTEMP=Tip(bouTEMP,"TempCPU de tous les présents")

	bouCAPT= Button(can1,text="CAPTURE-ECRAN",command=CAPTURE,bg='lightblue',fg=coulFG1)
	bouCAPT.place(x=840,y=15,width=130,height=30)
	tipCAPT=Tip(bouCAPT,"Capture Ecran")
	
	bouAIDE= Button(can1,text="AIDE",bg='lightgrey',fg=coulFG1)
	bouAIDE.place(x=1010,y=15,height=30)
	tipAIDE=Tip(bouAIDE,"Click-Gauche >> A Propos\nClick-Droit >> Notice")
	bouAIDE.bind("<ButtonRelease-1>",partial(Apropos,False))
	bouAIDE.bind("<ButtonRelease-3>",partial(Apropos,True))

	bouTEST= Button(can1,text="TEST-IP",command=TESTIP,bg='lightgrey',fg=coulFG1)
	bouTEST.place(x=W-300,y=5,width=70,height=28)
	tipTEST=Tip(bouTEST,"Vérifit les présents\nEt met à jour leur Nom")
	checkTEST=Checkbutton(can1,text="Auto",variable=VarTEST,bg='lightgrey',fg=coulFG1)
	checkTEST.place(x=W-300,y=34)
	tipcheckTEST=Tip(checkTEST,"Analyse des Présents\nAutomatique")

	bouSCAN1= Button(can1,text="SCAN-IP-1",command=partial(ScanIP,1),bg='lightgrey',fg=coulFG1)
	bouSCAN1.place(x=W-180,y=7,width=80,height=20)
	tipSCAN1=Tip(bouSCAN1,"Analyse des IP du réseau\nEntre 2 et 100")
	bouSCAN2= Button(can1,text="SCAN-IP-2",command=partial(ScanIP,2),bg='lightgrey',fg=coulFG1)
	bouSCAN2.place(x=W-180,y=32,width=80,height=20)
	tipSCAN2=Tip(bouSCAN2,"Analyse des IP du réseau\nEntre 100 et 200")
	
	

	if logo != None:
		lg=can1.create_image(W-50,30,image=logo,tag="cdl")

	if userP.get() == "":
		bouTEMP.configure(state= DISABLED)
		bouTEST.configure(state= DISABLED)
		bouSCAN.configure(state= DISABLED)

def AFFI_FEN2():
	global fen2,listF,bouCOPIE
	fen2=Toplevel(fen1)
	fen2.title("TRANSFERT FICHIERS/DOSSIER")
	#fen2.overrideredirect(True)		#sans barre de titre
	x=checkBW[0].winfo_rootx()
	y=checkBW[0].winfo_rooty()
	fen2.geometry("400x400" + '+' + str(x) + '+' + str(y))
	fen2.config(bg=coulBG1)
	labO=Label(fen2,text="CHEMIN LOCAL ORIGINE")
	labO.place(x=10,y=10)
	labO.configure(bg=coulBG1,fg='black')
	EntreeORI=Entry(fen2,textvariable=VarORI,font=("Arial",10),width=52,bg='white',fg=coulFG1,relief='solid',bd=1)
	EntreeORI.place(x=10,y=30)
	tipEntreeORI=Tip(EntreeORI,"Click-Droit pour Choix Fichiers ou Dossier")
	EntreeORI.bind('<ButtonRelease-3>',ChoixORIF)
	labD=Label(fen2,text="DESTINATION ")
	labD.place(x=10,y=60)
	labD.configure(bg=coulBG1,fg='black')
	labDIP=Label(fen2,text="IP")
	labDIP.place(x=10,y=85)
	labDIP.configure(bg=coulBG1,fg=coulFG1)
	EntreeDIP=Entry(fen2,textvariable=VarDESTIIP,font=("Arial",10),width=12,bg='white',fg=coulFG1,relief='solid',bd=1)
	EntreeDIP.place(x=80,y=85)
	tipDIP=Tip(EntreeDIP,"IP de Destination\nClick sur IP de la liste")
	labDCHE=Label(fen2,text="Chemin")
	labDCHE.place(x=10,y=110)
	labDCHE.configure(bg=coulBG1,fg=coulFG1)
	EntreeDCHE=Entry(fen2,textvariable=VarDESTI,font=("Arial",10),width=42,bg='white',fg=coulFG1,relief='solid',bd=1)
	EntreeDCHE.place(x=80,y=110)
	tipDCHE=Tip(EntreeDCHE,"Chemin de Destination\nClick Droit pour Voir et Vérifier")
	EntreeDCHE.bind('<ButtonRelease-3>',VoirDESTI)
	listF=Listbox(fen2,width=52,height=13,font=('Arial',10),selectmode=None,relief='solid',bg=coulBG1,border=1)
	listF.place(x=10,y=140)
	
	bouRAZ= Button(fen2,text="RAZ",command=RazCOPI,bg=coulBG1,fg='blue')
	bouRAZ.place(x=50,y=370,width=100,height=25)

	bouCOPIE= Button(fen2,text="COPIER",command=COPIFICH,bg=coulBG1,fg='blue')
	bouCOPIE.place(x=250,y=370,width=100,height=25)
	bouCOPIE.configure(state=DISABLED)

	#Rempli la ligne de commande pour le Nom
	cmd=[]
	cmd.append (VarDESTIIP.get())
	cmd.append (userN.get())
	cmd.append (userP.get())
	cmd.append ("")
	t=SSH.Nom_Raspi(cmd)
	if t == "":
		labD.configure(text="DESTINATION >> NON DISPONIBLE")
		EntreeDIP.configure(fg='red')
		bouCOPIE.configure(state=DISABLED)
	else:
		labD.configure(text="DESTINATION >> " + t)
		EntreeDIP.configure(fg=coulFG1)
	#Liste des Fichiers
	listF.delete(0,END)
	for i in range(0,len(CopieTAB)):
		listF.insert(END,CopieTAB[i])
	if typeREP:
		labO.configure(text="DOSSIER ORIGINE")
	else:
		labO.configure(text="FICHIERS ORIGINE")
	if VarORI.get() != "" and VarDESTIIP.get() != "":bouCOPIE.configure(state=ACTIVE)
	fen2.update()
	#On met en Modal
	fen1.wait_window(fen2)

def AFFI_FEN3():
	global fen3
	fen3=Toplevel(fen1)
	fen3.title("CAPTURE ECRAN")
	#Centrage de fen3
	fen3.geometry("300x130+" + str(int((scrW-300)/2)) + '+' + str(int((scrH-130)/3)))
	fen3.config(bg=coulBG1)
	choix0=Radiobutton(fen3,text='Ecran',variable=VarCAPT,value=0,bg=coulBG1,fg=coulFG1,font=('Arial',10))
	choix0.place(x=10,y=10)
	choix1=Radiobutton(fen3,text='Fenetre Active',variable=VarCAPT,value=1,bg=coulBG1,fg=coulFG1,font=('Arial',10))
	choix1.place(x=10,y=30)
	choix2=Radiobutton(fen3,text='Sélection Souris',variable=VarCAPT,value=2,bg=coulBG1,fg=coulFG1,font=('Arial',10))
	choix2.place(x=10,y=50)
	labCHE=Label(fen3,text="Chemin Destination")
	labCHE.place(x=10,y=75)
	labCHE.configure(bg=coulBG1,fg=coulFG1)
	EntreeCHE=Entry(fen3,textvariable=VarDESTICE,font=("Arial",10),width=40,bg='white',fg=coulFG1,relief='solid',bd=1)
	EntreeCHE.place(x=10,y=95)
	tipCHE=Tip(EntreeCHE,"Chemin de Destination\nClick Droit pour Voir et Vérifier")
	EntreeCHE.bind('<ButtonRelease-3>',VoirDESTI_LOCAL_CE)
	bouCAPT= Button(fen3,text="CAPTURE (10s)",command=CAPT_ECRAN,bg=coulBG1,fg=coulFG1)
	bouCAPT.place(x=170,y=30,width=110,height=35)
	
def Apropos(notice,e):
	affiT.delete('0.0',END)
	aide = ver + "\n"
	aide += "CDBI   Juillet/Aout 2021\n\n"
	aide += "Commandes entre Raspis en SSH\n"
	aide += "Transfert de Fichier/Dossier entre Raspis en SCP-1\n"
	aide += "Capture d'Ecran\n\n"
	aide += "CLICK-DROIT POUR LA NOTICE"
	affiT.insert(END,aide)
	pt2= "2.85"
	pt1= "1.0"
	affiT.tag_add('pointage',pt1,pt2)

	if notice:
		try:
			#cmd="libreoffice -o " + FichierAide
			cmd="qpdfview " + FichierAide
			lib1.run_cmd(cmd)
		except:
			affiT.insert(END,"\n\nNOTICE NON DISPONIBLE\n")
			pt2= "10.85"
			pt1= "10.0"
			affiT.tag_add('pointage',pt1,pt2)

def FenDIM():
	H=int(110+(25*VarNbIP.get()))
	W=1420
	#Centrage de fen1
	fen1.geometry(str(W) + "x" + str(H) + '+' + str(int((scrW-W)/2)) + '+' + str(int((scrH-H)/3)))
	fen1.config(bg='lightgreen')

#------------------ MAIN -------------------------------
ver='Lanceur sur IP  1.0.7'
FichierConf=sys.path[0] + "/Lanceur-IP-107.conf"
FichierAide=sys.path[0] + "/Lanceur-IP-107.pdf"

fen1 = Tk()
fen1.title(lib1.get_nom() + "  " + ver)
fen1.pack_propagate(True)
fen2=None
fen3=None

#Taille Ecran
tscreen=lib1.Taillescreen()
scrW=int(tscreen[0])
scrH=int(tscreen[1])

localIP=lib1.get_ip()
VarNbIP=IntVar()
NouvNbIP=IntVar()
arretSCAN=True
MAJdate=[]
userN=StringVar()
userP=StringVar()
userN.set("pi")
userP.set("")
VarNbIP.set(0)
NouvNbIP.set(0)
VarORI=StringVar()
VarDESTIIP=StringVar()
VarDESTI=StringVar()
VarDESTI.set("/home/pi/")
VarDESTICE=StringVar()
VarDESTICE.set("/home/pi/Pictures/")
VarTEST=IntVar()
VarTEST.set(True)
VarCMD=StringVar()
VarCAPT=IntVar()
typeREP=False
CopieTAB=[]
icon="./Cdpetit.gif"
logo=None
flagAPP=False       #Affiche ou non A propos

"""
	A MODIFIER SELON vos préférences
"""
coulBG1='lightblue'
coulBG2='lightgreen'
coulFG1='darkblue'
coulFG2='darkred'

if lib1.Existe(icon):
	logo=PhotoImage(file=icon)
can0=None
can1=None
REFRESH(True)

fen1.mainloop()

#ENR_Config(FichierConf)
exit()
