#!/usr/bin/env python3.7
# -*- coding: utf-8 -*-

"""
	CDBI	Septembre 2019
CDBI1	Classe générale
il faut sudo pip3 install psutil
"""

import os,sys,psutil
import threading
import shlex,subprocess
from subprocess import call
from datetime import datetime
from time import sleep
import wave
import RPi.GPIO as GPIO

class CDBI1:
	def __init__(self):
		sleep(0.001)

	def Taillescreen(self):
		sc=os.popen("xrandr -q -d :0").readlines(1)[0]
		w=sc.split()[7]
		h=sc.split()[9][:-1]
		self.Effa_Termi()
		return w,h

	def FenetreDIM(self,fen):
		#Retourne W,H,X,Y
		fen.update()
		g=fen.geometry()
		r=[i for i in range(0,len(g)) if not g[i].isdigit()]
		return [int(g[0:r[0]]),int(g[r[0]+1:r[1]]),int(g[r[1]+1:r[2]]),int(g[r[2]+1:])]

	def Existe(self,f):
		#Fonctionne pour Fichier et Dossier
		return os.path.exists(f)

	def run_cmd(self,cmd):
		r=subprocess.check_output(cmd, shell=True).decode('utf-8')
		return r

	def get_ip(self):
		#cmd="hostname --all-ip-addresses"
		cmd = "hostname -I | cut -d\' \' -f1"
		return str(self.run_cmd(cmd)[:-1])

	def get_nom(self):
		cmd = "hostname | cut -d\' \' -f1"
		return str(self.run_cmd(cmd)[:-1])

	def Extract_Chemin(self,rep,mode):
		r=os.path.split(rep)
		if mode == True:
			#retour du chemin
			return r[0]
		else:
			#retour du nom fichier avec Extension
			return r[1]

	def Explo(self,rep):
		#mode Dossier
		if self.Existe(rep):
			os.chdir(rep)
			os.system("pcmanfm")

	def Effa_Termi(self):
		print ("\033c")
		os.system("clear")

	def DIT(self,t,flagSON):
		FichierParle="./DIT.wav"
		if flagSON and (t !=""):
			#try:
			#Remplacer les Espaces par des # pour la ligne de commande
			td=str.upper(t)
			td=td.replace(" ","###")
			td=td.replace(".","###,")
			cmd="pico2wave -l=fr-FR -w=" + FichierParle + " %s" %td
			call(cmd,shell=True)
			self.Lire_WAV(FichierParle)
			return 1
			#except:
			#	return 0

	def Lire_WAV(self,f):
		t=threading.Thread(target=self._Lire_WAV1(f))

	def _Lire_WAV1(self,f):
		pro=None
		cmd="aplay -q -f S16_LE -r 16000 %s" % f
		#cmd="aplay -q " + f
		pro=subprocess.Popen(shlex.split(cmd),stdin=subprocess.PIPE,stdout=subprocess.PIPE,stderr=None,bufsize=0)
		sleep(0.1)
		#on attend la fin
		while pro.poll() is  None:
			sleep(0.1)
		pro.terminate()

	def _Lire_WAV2(self,f):
		with wave.open(f,'rb') as w:
			sortie=alsaaudio.PCM()
			sortie.setchannels(w.getnchannels())
			sortie.setrate(w.getframerate())
			sortie.setformat(alsaaudio.PCM_FORMAT_S16_LE)
			sortie.setperiodsize(1024)
			while True:
				try:
					data=w.readframes(1024)
					if not data:break
					sortie.write(data)
				except KeyboardInterrupt:
					break
			sortie.close()
			w.close()
			w=None
			sortie=None

	def BEEP(self,Freq):
		Buz=GPIO.PWM(18,Freq)
		Buz.start(10)
		sleep(0.3)
		Buz.stop()
		sleep(0.1)

	def get_CPUtemp(self):
		#t=psutil.sensors_temperatures()
		#print (t)
		cmd="vcgencmd measure_temp"
		r=str(self.run_cmd(cmd))
		return  r[5:len(r)-3]

	def Verif_Alim(self):
		cmd="vcgencmd get_throttled"
		r=str(self.run_cmd(cmd))
		r=r[10:]
		if r != "0x0":
			return True
		else:
			return False

	def get_Memoire(self):
		cmd = "free -m | awk 'NR==2{printf \"Mem: %s/%sMo %.2f%%\", $3,$2,$3*100/$2 }'"
		return str(self.run_cmd(cmd))
		#ram=psutil.virtual_memory()
		#return str(ram.available)

	def get_Disk(self):
		cmd = "df -h | awk '$NF==\"/\"{printf \"Disk: %d/%dGo %s\", $3,$2,$5}'"
		return str(self.run_cmd(cmd))

	def get_CPUload(self):
			return str(psutil.cpu_percent(interval=1))

	def now_Heure(self):
		hour = datetime.now().strftime('%H')
		minute = datetime.now().strftime('%M')
		second = datetime.now().strftime('%S')
		return hour,minute,second

	def now_Date(self):
		j=datetime.now().strftime('%d')
		m=datetime.now().strftime('%m')
		a=datetime.now().strftime('%Y')
		return j,m,a
		
	def Formater_Nom(self,rep):
		""" Remplace espaces par tirets"""
		if self.Existe(rep):
			cmd="find " + rep +" -type f -exec rename 's/ /-/g' {} \;"
			os.system(cmd)
