#!/usr/bin/env python3.7
# -*- coding: utf-8 -*-

"""
	CDBI	Juillet 2021
	SSH	Classe générale avec SCP
	il faut sudo pip3 install paramiko pour le SSH
				SSH						SCP
	source[0]	IP						IP destination
	source[1]	user					User
	source[2]	Passe					Passe
	source[3]	Commande				True si copie de Dossier
	source[4]	Non Utilisé				Dossier/Fichier origine
	source[5]	Nom Fichier à lire		Dossier Destination
"""

from time import sleep
from paramiko import SSHClient
from paramiko import AutoAddPolicy
import clsSCP
from clsSCP import SCPClient

class SSH():
	def __init__(self):
		self.msgCONNECT="ERREUR IDENTIFICATION"
		sleep(0.001)

	def ConvB(self,r):
		s=str(r)
		s=s.replace("b","")
		return s.replace("'","")

	def Traitement(self,s):
		s=s.replace("\\xc3\\xa0","à")
		s=s.replace("\\xc3\\xa9","é")
		s=s.replace("\\xc3\\xa8s","è")
		s=s.replace("\\xe2\\x80\\xa6","  ok")
		s=s.replace("\\xc2\\xa0"," ")
		s=s.replace("\\xc2\\xab","<<")
		s=s.replace("\\xc2\\xbb",">>")
		s=s.replace("\\"," ")
		s=s.replace("[b","")
		s=s.replace("]","\n")
		s=s.replace("["," ")
		s=s[1:][:-1]
		return s

	def Lire_file(self,source):
		t=[]
		try:
			client = SSHClient()
			client.load_system_host_keys()
			client.set_missing_host_key_policy(AutoAddPolicy())
			client.connect(source[0],username=source[1],password=source[2],timeout=5)
			stdin,stdout,stderr=client.exec_command("cat " + source[3]+source[5])
			#Attendre la fin
			while not stdout.channel.exit_status_ready():
				sleep(0.01)
			t=[]
			for line in stdout.read().splitlines():
				#l=str(line)
				l=self.ConvB(line)[1:]
				t.append(l)
			client.close()
			return t
		except:
			client.close()
			return ""

	def Lire_tuple(self,source,sep=','):
		try:
			client = SSHClient()
			client.load_system_host_keys()
			client.set_missing_host_key_policy(AutoAddPolicy())
			client.connect(source[0],username=source[1],password=source[2],timeout=5)
			stdin,stdout,stderr=client.exec_command("cat " + source[3] + source[5])
			#Attendre la fin
			while not stdout.channel.exit_status_ready():
				sleep(0.01)
			Sout=self.ConvB(stdout.read())
			client.close()
			t=[]
			t=tuple(map(str,Sout.split(sep)))
			return t
		except:
			client.close()
			return ""

	def execute_command(self,command):
		try:
			client = SSHClient()
			client.load_system_host_keys()
			client.set_missing_host_key_policy(AutoAddPolicy())
			client.connect(command[0], username=command[1], password=command[2],timeout=5)
			stdin,stdout,stderr = client.exec_command(command[3])
			#Attendre la fin
			while not stdout.channel.exit_status_ready():
				sleep(0.01)
			r_out, r_err = stdout.read().splitlines(), stderr.read()
			client.close()
			return r_out, r_err
		except:
			client.close()
			return False

	def CPUtemp(self,source):
		source[3]="vcgencmd measure_temp"
		r=self.execute_command(source)
		if r == False:
			return ""
		else:
			t=self.ConvB(r[0])
			return t[7:len(t)-2]

	def Nom_Raspi(self,source):
		source[3] = "hostname"
		r=self.execute_command(source)
		if r == False:
			return ""
		else:
			t=self.ConvB(r[0])
			t=t[1:len(t)-1]
			return t

	def CPU_INFO(self,source):
		source[3] = "cat /proc/cpuinfo"
		r=self.execute_command(source)
		if r == False:
			return ""
		else:
			r=str(r[0][1:])
			r=r.split(', b')
			t=""
			for i in range (0,len(r)):
				s=str(r[i])
				s=self.Traitement(s)
				t += s + "\n"

		source[3] = "free -m"
		r=self.execute_command(source)
		if r == False:
			return t
		else:
			t=t + "\nMEMOIRE\n"
			n="                   Total      Utilisée    Libre       Shared     Cache     Dispo\n"
			t += n
			r=str(r[0][1:])
			r=r.split(', b')
			for i in range (0,len(r)):
				s=str(r[i])
				s=self.Traitement(s)
				t += s + "\n"
		return t

	def MAJ(self,source):
		source[3] = "sudo apt-get update -y && sudo apt-get upgrade -y"
		r=self.execute_command(source)
		if r == False:
			return ""
		else:
			r=str(r[0][1:])
			r=r.split(', b')
			t=""
			for i in range (0,len(r)):
				s=str(r[i])
				s=self.Traitement(s)
				t += s + "\n"

		source[3] = "sudo apt-get autoremove -y"
		r=self.execute_command(source)
		if r == False:
			return t
		else:
			t=t + "\nAUTOREMOVE\n"
			r=str(r[0][1:])
			r=r.split(', b')
			for i in range (0,len(r)):
				s=str(r[i])
				s=self.Traitement(s)
				t += s + "\n"
			return t

	def LireDossier(self,source):
		source[3] = "ls " + source[5]
		r=self.execute_command(source)
		if r == False:
			return "ERREUR ou NON DISPONIBLE\n"
		else:
			if len(str(r[0])) == 2:
				return "VIDE\n"
			else:
				r=str(r[0][1:])
				r=r.split(', b')
				t=""
				for i in range (0,len(r)):
					s=str(r[i])
					s=self.Traitement(s)
					t += s + "\n"
				return t

	def REBOOT(self,source):
		source[3] = "sudo reboot"
		r=self.execute_command(source)
		sleep(30)
		if r == False:
			return ""
		else:
			t=self.ConvB(r[0])
			t=t[1:len(t)-1]
			return t
	
	def SHUTD(self,source):
		source[3] = "sudo shutdown -h now"
		r=self.execute_command(source)
		sleep(1)

	def COMMAND(self,source):
		r=self.execute_command(source)
		if r == False:
			return "ERREUR COMMANDE ou NON DISPONIBLE\n"
		else:
			t=""
			for k in range(0,len(r)):
				tr=str(r[k][1:])
				tr=tr.split(', b')
				for i in range (0,len(tr)):
					s=str(tr[i])
					s=self.Traitement(s)
					t += s + "\n"
			return t

	def TRANSFERT(self,source):
		#On établi la connection
		if source[0] == "":
			return "PAS D'IP DEFINI !!"
		try:
			client = SSHClient()
			client.load_system_host_keys()
			client.set_missing_host_key_policy(AutoAddPolicy())
			client.connect(source[0], username=source[1], password=source[2],timeout=5)
		except:
			return source[0] + "  NON DISPONIBLE\n"
		#On lance SCP
		try:
			SCP=SCPClient(client.get_transport())
			SCP.put(source[4],recursive=int(source[3]),remote_path=source[5])
			SCP.close()
			return source[4] + " >> COPIE OK\n"
		except:
			SCP.close()
			return source[4] + " >> ERREUR COPIE\n"

