#!/usr/bin/env python3.7
# -*- coding: utf-8 -*-
#
#  clsToolTip.py	Juillet 2021
#	Fenetre toplevel pour ToolTip  
#	Modifit le curseur en hand1

import tkinter as tk

class ToolTip():
	def __init__(self,widget=None,text=""):
		super().__init__()
		self.widget=widget
		self.text=text
		self.wait=400
		if not self.widget == None:
			self.widget.configure(cursor='hand1')
			self.widget.bind('<Enter>',self.on_enter)
			self.widget.bind('<Leave>',self.on_leave)
			self.widget.bind('<ButtonPress>',self.on_leave)
			self.widget.bind('<Return>',self.on_leave)
			self.widget.bind('<KeyPress>',self.on_leave)


	def show(self,event):
		self.fentip=tk.Toplevel()
		self.fentip.overrideredirect(True)		#efface la fenetre
		self.fentip.geometry(f'+{event.x_root+2}+{event.y_root+2}')
		self.label=tk.Label(self.fentip,text=self.text)
		self.label.configure(bg='white',border=1,relief='solid')
		self.label.pack()
		self.fentip.update()

	def on_enter(self,event):
		#Attend pour valider le widget
		self.widget.after(self.wait,self.show(event))
		#self.show(event)

	def on_leave(self,event):
		self.fentip.destroy()


